Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## java.lang
Class Long

    java.lang.Object
      |
      +--java.lang.Number
            |
            +--java.lang.Long

All Implemented Interfaces:
  Comparable, Serializable

public final class Long
extends Number
implements Comparable

The Long class wraps a value of the primitive type `long` in an object. An object of type `Long` contains a single field whose type is `long`.

In addition, this class provides several methods for converting a `long` to a `String` and a `String` to a `long`, as well as other constants and methods useful when dealing with a `long`.

Since:
  JDK1.0
See Also:
  Serialized Form

Field Summary
`static long` | `MAX_VALUE` The largest value of type `long`.
`static long` | `MIN_VALUE` The smallest value of type `long`.
`static Class` | `TYPE` The Class object representing the primitive type long.

Constructor Summary
`Long(long value)` Constructs a newly allocated `Long` object that represents the primitive `long` argument.
`Long(String s)` Constructs a newly allocated `Long` object that represents the value represented by the string in decimal form.

Method Summary
`byte` | `byteValue()` Returns the value of this Long as a byte.
`int` | `compareTo(Long anotherLong)` Compares two Longs numerically.
`int` | `compareTo(Object o)` Compares this Long to another Object.
`static Long` | `decode(String nm)` Decodes a `String` into a `Long`.
`double` | `doubleValue()` Returns the value of this Long as a double.
`boolean` | `equals(Object obj)` Compares this object against the specified object.
`float` | `floatValue()` Returns the value of this Long as a float.
`static Long` | `getLong(String nm)` Determines the `long` value of the system property with the specified name.
`static Long` | `getLong(String nm, long val)` Determines the `long` value of the system property with the specified name.
`static Long` | `getLong(String nm, Long val)` Returns the long value of the system property with the specified name.
`int` | `hashCode()` Computes a hashcode for this Long.
`int` | `intValue()` Returns the value of this Long as an int.
`long` | `longValue()` Returns the value of this Long as a long value.
`static long` | `parseLong(String s)` Parses the string argument as a signed decimal `long`.
`static long` | `parseLong(String s, int radix)` Parses the string argument as a signed `long` in the radix specified by the second argument.
`short` | `shortValue()` Returns the value of this Long as a short.
`static String` | `toBinaryString(long i)` Creates a string representation of the long argument as an unsigned integer in base 2.
`static String` | `toHexString(long i)` Creates a string representation of the long argument as an unsigned integer in base 16.
`static String` | `toOctalString(long i)` Creates a string representation of the long argument as an unsigned integer in base 8.
`String` | `toString()` Returns a String object representing this Long's value.
`static String` | `toString(long i)` Returns a new String object representing the specified integer.
`static String` | `toString(long i, int radix)` Creates a string representation of the first argument in the radix specified by the second argument.
`static Long` | `valueOf(String s)` Returns a new long object initialized to the value of the specified String.
`static Long` | `valueOf(String s, int radix)` Returns a new long object initialized to the value of the specified String.

Methods inherited from class java.lang.Object
`clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

Field Detail

### MIN_VALUE

    public static final long MIN_VALUE

  The smallest value of type `long`.

### MAX_VALUE

    public static final long MAX_VALUE

  The largest value of type `long`.

### TYPE

    public static final Class TYPE

  The Class object representing the primitive type long.
  Since:
    JDK1.1

Constructor Detail

### Long

    public Long(long value)

  Constructs a newly allocated `Long` object that represents the primitive `long` argument.
  Parameters:
    `value` - the value to be represented by the `Long` object.

### Long

    public Long(String s)
         throws NumberFormatException

  Constructs a newly allocated `Long` object that represents the value represented by the string in decimal form. The string is converted to an `long` value as if by the `parseLong(java.lang.String, int)` method for radix 10.
  Parameters:
    `s` - the string to be converted to a `Long`.
  Throws:
    `NumberFormatException` - if the `String` does not contain a parsable long integer.
  See Also:
    `valueOf(java.lang.String)`

Method Detail

### toString

    public static String toString(long i,
                                  int radix)

  Creates a string representation of the first argument in the radix specified by the second argument.

  If the radix is smaller than `Character.MIN_RADIX` or larger than `Character.MAX_RADIX`, then the radix `10` is used instead.

  If the first argument is negative, the first element of the result is the ASCII minus sign `'-'` (`'\u002d'`. If the first argument is not negative, no sign character appears in the result.

  The remaining characters of the result represent the magnitude of the first argument. If the magnitude is zero, it is represented by a single zero character `'0'` (`'\u0030'`); otherwise, the first character of the representation of the magnitude will not be the zero character. The following ASCII characters are used as digits:

  >        0123456789abcdefghijklmnopqrstuvwxyz

  These are `'\u0030'` through `'\u0039'` and `'\u0061'` through `'\u007a'`. If the radix is N, then the first N of these characters are used as radix-N digits in the order shown. Thus, the digits for hexadecimal (radix 16) are `0123456789abcdef`. If uppercase letters are desired, the `String.toUpperCase()` method may be called on the result:

  >      Long.toString(n, 16).toUpperCase()

  Parameters:
    `i` - a long.
    `radix` - the radix.
  Returns:
    a string representation of the argument in the specified radix.
  See Also:
    `Character.MAX_RADIX`, `Character.MIN_RADIX`

### toHexString

    public static String toHexString(long i)

  Creates a string representation of the long argument as an unsigned integer in base 16.

  The unsigned long value is the argument plus 264 if the argument is negative; otherwise, it is equal to the argument.

  If the unsigned magnitude is zero, it is represented by a single zero character `'0'` (`'\u0030'`); otherwise, the first character of the representation of the unsigned magnitude will not be the zero character. The following characters are used as hexadecimal digits:

  >      0123456789abcdef

  These are the characters `'\u0030'` through `'\u0039'` and '\u0061' through `'\u0066'`. If uppercase letters are desired, the `String.toUpperCase()` method may be called on the result:

  >      Long.toHexString(n).toUpperCase()

  Parameters:
    `i` - a `long`.
  Returns:
    the string representation of the unsigned long value represented by the argument in hexadecimal (base 16).
  Since:
    JDK 1.0.2

### toOctalString

    public static String toOctalString(long i)

  Creates a string representation of the long argument as an unsigned integer in base 8.

  The unsigned long value is the argument plus 264 if the argument is negative; otherwise, it is equal to the argument.

  If the unsigned magnitude is zero, it is represented by a single zero character `'0'` (`'\u0030'`); otherwise, the first character of the representation of the unsigned magnitude will not be the zero character. The following characters are used as octal digits:

  >      01234567

  These are the characters `'\u0030'` through `'\u0037'`.
  Parameters:
    `i` - a `long`.
  Returns:
    the string representation of the unsigned long value represented by the argument in octal (base 8).
  Since:
    JDK 1.0.2

### toBinaryString

    public static String toBinaryString(long i)

  Creates a string representation of the long argument as an unsigned integer in base 2.

  The unsigned long value is the argument plus 264 if the argument is negative; otherwise, it is equal to the argument.

  If the unsigned magnitude is zero, it is represented by a single zero character `'0'` (`'&392;u0030'`); otherwise, the first character of the representation of the unsigned magnitude will not be the zero character. The characters `'0'` (`'\u0030'`) and `'1'` (`'\u0031'`) are used as binary digits.

  Parameters:
    `i` - a long.
  Returns:
    the string representation of the unsigned long value represented by the argument in binary (base 2).
  Since:
    JDK 1.0.2

### toString

    public static String toString(long i)

  Returns a new String object representing the specified integer. The argument is converted to signed decimal representation and returned as a string, exactly as if the argument and the radix 10 were given as arguments to the `toString(long, int)` method that takes two arguments.
  Parameters:
    `i` - a `long` to be converted.
  Returns:
    a string representation of the argument in base 10.

### parseLong

    public static long parseLong(String s,
                                 int radix)
                          throws NumberFormatException

  Parses the string argument as a signed `long` in the radix specified by the second argument. The characters in the string must all be digits of the specified radix (as determined by whether `Character.digit` returns a nonnegative value), except that the first character may be an ASCII minus sign `'-'` (`'\u002d'` to indicate a negative value. The resulting `long` value is returned.

  Note that neither `L` nor `l` is permitted to appear at the end of the string as a type indicator, as would be permitted in Java programming language source code - except that either `L` or `l` may appear as a digit for a radix greater than 22.

  An exception of type `NumberFormatException` is thrown if any of the following situations occurs:

  - The first argument is `null` or is a string of length zero.
  - The `radix` is either smaller than `Character.MIN_RADIX` or larger than `Character.MAX_RADIX`.
  - The first character of the string is not a digit of the specified `radix` and is not a minus sign `'-'` (`'\u002d'`).
  - The first character of the string is a minus sign and the string is of length 1.
  - Any character of the string after the first is not a digit of the specified `radix`.
  - The integer value represented by the string cannot be represented as a value of type `long`.

  Examples:

  >      parseLong("0", 10) returns 0L
  >      parseLong("473", 10) returns 473L
  >      parseLong("-0", 10) returns 0L
  >      parseLong("-FF", 16) returns -255L
  >      parseLong("1100110", 2) returns 102L
  >      parseLong("99", 8) throws a NumberFormatException
  >      parseLong("Hazelnut", 10) throws a NumberFormatException
  >      parseLong("Hazelnut", 36) returns 1356099454469L

  Parameters:
    `s` - the `String` containing the `long`.
    `radix` - the radix to be used.
  Returns:
    the `long` represented by the string argument in the specified radix.
  Throws:
    `NumberFormatException` - if the string does not contain a parsable integer.

### parseLong

    public static long parseLong(String s)
                          throws NumberFormatException

  Parses the string argument as a signed decimal `long`. The characters in the string must all be decimal digits, except that the first character may be an ASCII minus sign `'-'` (`\u002d'`) to indicate a negative value. The resulting long value is returned, exactly as if the argument and the radix `10` were given as arguments to the `parseLong(String, int)` method that takes two arguments.

  Note that neither `L` nor `l` is permitted to appear at the end of the string as a type indicator, as would be permitted in Java programming language source code.

  Parameters:
    `s` - a string.
  Returns:
    the `long` represented by the argument in decimal.
  Throws:
    `NumberFormatException` - if the string does not contain a parsable `long`.

### valueOf

    public static Long valueOf(String s,
                               int radix)
                        throws NumberFormatException

  Returns a new long object initialized to the value of the specified String. Throws an exception if the String cannot be parsed as a long.

  The first argument is interpreted as representing a signed integer in the radix specified by the second argument, exactly as if the arguments were given to the `parseLong(java.lang.String, int)` method that takes two arguments. The result is a `Long` object that represents the integer value specified by the string.

  In other words, this method returns a `Long` object equal to the value of:

  >      new Long(Long.parseLong(s, radix))

  Parameters:
    `s` - the `String` containing the `long`.
    `radix` - the radix to be used.
  Returns:
    a newly constructed `Long` initialized to the value represented by the string argument in the specified radix.
  Throws:
    `NumberFormatException` - If the `String` does not contain a parsable `long`.

### valueOf

    public static Long valueOf(String s)
                        throws NumberFormatException

  Returns a new long object initialized to the value of the specified String. Throws an exception if the String cannot be parsed as a long. The radix is assumed to be 10.

  The argument is interpreted as representing a signed decimal integer, exactly as if the argument were given to the `parseLong(java.lang.String)` method that takes one argument). The result is a `Long` object that represents the integer value specified by the string.

  In other words, this method returns a `Long` object equal to the value of:

  >      new Long(Long.parseLong(s))

  Parameters:
    `s` - the string to be parsed.
  Returns:
    a newly constructed `Long` initialized to the value represented by the string argument.
  Throws:
    `NumberFormatException` - If the `String` does not contain a parsable `long`.

### decode

    public static Long decode(String nm)
                       throws NumberFormatException

  Decodes a `String` into a `Long`. Accepts decimal, hexadecimal, and octal numbers, in the following formats:

           [-]        decimal constant
           [-] 0x     hex constant
           [-] #      hex constant
           [-] 0      octal constant

  The constant following an (optional) negative sign and/or "radix specifier" is parsed as by the `Long.parseLong` method with the specified radix (10, 8 or 16). This constant must be positive or a NumberFormatException will result. The result is made negative if first character of the specified `String` is the negative sign. No whitespace characters are permitted in the `String`.
  Parameters:
    `nm` - the `String` to decode.
  Returns:
    the `Long` represented by the specified string.
  Throws:
    `NumberFormatException` - if the `String` does not contain a parsable long.
  See Also:
    `parseLong(String, int)`

### byteValue

    public byte byteValue()

  Returns the value of this Long as a byte.
  Overrides:
    `byteValue` in class `Number`
  Since:
    JDK1.1

### shortValue

    public short shortValue()

  Returns the value of this Long as a short.
  Overrides:
    `shortValue` in class `Number`
  Since:
    JDK1.1

### intValue

    public int intValue()

  Returns the value of this Long as an int.
  Overrides:
    `intValue` in class `Number`
  Returns:
    the `long` value represented by this object is converted to type `int` and the result of the conversion is returned.

### longValue

    public long longValue()

  Returns the value of this Long as a long value.
  Overrides:
    `longValue` in class `Number`
  Returns:
    the `long` value represented by this object.

### floatValue

    public float floatValue()

  Returns the value of this Long as a float.
  Overrides:
    `floatValue` in class `Number`
  Returns:
    the `long` value represented by this object is converted to type `float` and the result of the conversion is returned.

### doubleValue

    public double doubleValue()

  Returns the value of this Long as a double.
  Overrides:
    `doubleValue` in class `Number`
  Returns:
    the `long` value represented by this object that is converted to type `double` and the result of the conversion is returned.

### toString

    public String toString()

  Returns a String object representing this Long's value. The long integer value represented by this Long object is converted to signed decimal representation and returned as a string, exactly as if the long value were given as an argument to the `toString(long)` method that takes one argument.
  Overrides:
    `toString` in class `Object`
  Returns:
    a string representation of this object in base 10.

### hashCode

    public int hashCode()

  Computes a hashcode for this Long. The result is the exclusive OR of the two halves of the primitive `long` value represented by this `Long` object. That is, the hashcode is the value of the expression:

  >      (int)(this.longValue()^(this.longValue()>>>32))

  Overrides:
    `hashCode` in class `Object`
  Returns:
    a hash code value for this object.

### equals

    public boolean equals(Object obj)

  Compares this object against the specified object. The result is `true` if and only if the argument is not `null` and is a `Long` object that contains the same `long` value as this object.
  Overrides:
    `equals` in class `Object`
  Parameters:
    `obj` - the object to compare with.
  Returns:
    `true` if the objects are the same; `false` otherwise.

### getLong

    public static Long getLong(String nm)

  Determines the `long` value of the system property with the specified name.

  The first argument is treated as the name of a system property. System properties are accessible through the `System.getProperty(java.lang.String)` method. The string value of this property is then interpreted as a long value and a `Long` object representing this value is returned. Details of possible numeric formats can be found with the definition of `getProperty`.

  If there is no property with the specified name, if the specified name is empty or null, or if the property does not have the correct numeric format, then `null` is returned.

  In other words, this method returns a `Long` object equal to the value of:

  >      getLong(nm, null)

  Parameters:
    `nm` - property name.
  Returns:
    the `Long` value of the property.
  See Also:
    `System.getProperty(java.lang.String)`, `System.getProperty(java.lang.String, java.lang.String)`

### getLong

    public static Long getLong(String nm,
                               long val)

  Determines the `long` value of the system property with the specified name.

  The first argument is treated as the name of a system property. System properties are accessible through the `System.getProperty(java.lang.String)` method. The string value of this property is then interpreted as a long value and a `Long` object representing this value is returned. Details of possible numeric formats can be found with the definition of `getProperty`.

  The second argument is the default value. A `Long` object that represents the value of the second argument is returned if there is no property of the specified name, if the property does not have the correct numeric format, or if the specified name is empty or null.

  In other words, this method returns a `Long` object equal to the value of:

  >      getLong(nm, new Long(val))

  but in practice it may be implemented in a manner such as:

  >      Long result = getLong(nm, null);
  >      return (result == null) ? new Long(val) : result;

  to avoid the unnecessary allocation of a `Long` object when the default value is not needed.
  Parameters:
    `nm` - property name.
    `val` - default value.
  Returns:
    the `Long` value of the property.
  See Also:
    `System.getProperty(java.lang.String)`, `System.getProperty(java.lang.String, java.lang.String)`

### getLong

    public static Long getLong(String nm,
                               Long val)

  Returns the long value of the system property with the specified name. The first argument is treated as the name of a system property. System properties are accessible through the `System.getProperty(java.lang.String)` method. The string value of this property is then interpreted as a long value, as per the `Long.decode` method, and a `Long` object representing this value is returned.

  - If the property value begins with the two ASCII characters `0x` or the ASCII character `#`, not followed by a minus sign, then the rest of it is parsed as a hexadecimal integer exactly as for the method `valueOf(java.lang.String, int)` with radix 16.
  - If the property value begins with the character `0` followed by another character, it is parsed as an octal integer exactly as for the method `valueOf(java.lang.String, int)` with radix 8.
  - Otherwise the property value is parsed as a decimal integer exactly as for the method `valueOf(java.lang.String, int)` with radix 10.

  Note that, in every case, neither `L` nor `l` is permitted to appear at the end of the property value as a type indicator, as would be permitted in Java programming language source code.

  The second argument is the default value. The default value is returned if there is no property of the specified name, if the property does not have the correct numeric format, or if the specified name is empty or null.

  Parameters:
    `nm` - property name.
    `val` - default value.
  Returns:
    the `Long` value of the property.
  See Also:
    `System.getProperty(java.lang.String)`, `System.getProperty(java.lang.String, java.lang.String)`, `decode(java.lang.String)`

### compareTo

    public int compareTo(Long anotherLong)

  Compares two Longs numerically.
  Parameters:
    `anotherLong` - the `Long` to be compared.
  Returns:
    the value `0` if the argument Long is equal to this Long; a value less than `0` if this Long is numerically less than the Long argument; and a value greater than `0` if this Long is numerically greater than the Long argument (signed comparison).
  Since:
    1.2

### compareTo

    public int compareTo(Object o)

  Compares this Long to another Object. If the Object is a Long, this function behaves like `compareTo(Long)`. Otherwise, it throws a `ClassCastException` (as Longs are comparable only to other Longs).
  Specified by:
    `compareTo` in interface `Comparable`
  Parameters:
    `o` - the `Object` to be compared.
  Returns:
    the value `0` if the argument is a Long numerically equal to this Long; a value less than `0` if the argument is a Long numerically greater than this Long; and a value greater than `0` if the argument is a Long numerically less than this Long.
  Throws:
    ``ClassCastException`` - if the argument is not a `Long`.
  Since:
    1.2
  See Also:
    `Comparable`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
| JavaTM 2 Platform Std. Ed. v1.3.1
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: INNER | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Submit a bug or feature
For further API reference and developer documentation, see Java 2 SDK SE Developer Documentation. That documentation contains more detailed, developer-targeted descriptions, with conceptual overviews, definitions of terms, workarounds, and working code examples.

Java, Java 2D, and JDBC are trademarks or registered trademarks of Sun Microsystems, Inc. in the US and other countries.
Copyright 1993-2001 Sun Microsystems, Inc. 901 San Antonio Road
Palo Alto, California, 94303, U.S.A. All Rights Reserved.